Index: WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/ZIS3.m
===================================================================
--- WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/ZIS3.m	(revision 613)
+++ WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/ZIS3.m	(revision 623)
@@ -1,82 +1,71 @@
-%ZIS3	;SFISC/AC,RWF -- DEVICE HANDLER(DEVICE TYPES & PARAMETERS) ;1/24/08  13:18
-	;;8.0;KERNEL;**18,36,69,104,391,440**;JUL 10, 1995;Build 13
-	;Per VHA Directive 2004-038, this routine should not be modified
-	;Call with a Go from ^%ZIS2
-	I %ZIS'["T",$G(^%ZIS(1,+%E,"POX"))]"" D XPOX^ZISX(%E) ;Pre-Open
-	I $D(%ZISQUIT) S POP=1 K %ZISQUIT
-	S %ZISCHK=1
-	;I 'POP&(%ZISB)&(%ZTYPE'="RES")&(%ZTYPE'="OTH")&(%ZTYPE'="SDP")&(IO'["::") D DEVOK
-	;See if need to lock.
-	K %ZISLOCK
-	I %ZIS'["T",+$G(^%ZIS(1,+%E,"GBL")) S %ZISLOCK=$NA(^%ZIS("lock",IO))
-	;
-	I 'POP G TRM:(%ZTYPE["TRM"),@(%ZTYPE_"^%ZIS6") ;Jump to next part
-	;
-Q	;%ZIS6 Returns here
-	;See if need to un-lock.
-	I $D(%ZISUOUT) K %ZISUOUT,%ZISHP,%ZISHPOP Q
-	I $D(%ZISHPOP)&$S(IO="":1,1:'$D(IO(1,IO))) D HGBSY^%ZIS2 Q
-	I POP S:%ZIS'["T" IO="" I $D(%ZISHG(0)),%ZIS'["D",'$D(%ZISHPOP) G HUNT^%ZIS2
-	Q  ;Return to %ZIS1
-	;
-VTRM	;Virtual terminal type
-TRM	;D OPEN^%ZIS4:'POP&(%ZISB&(%ZIS'["T")),MARGN:'POP,SETPAR:'POP ;Terminal type
-	D MARGN:'POP,SETPAR:'POP ;Terminal type// TEST CHANGE
-	I 'POP,%ZIS'["T",%ZISB=1,'$D(IOP),IO'=IO(0),'$D(IO("Q")),%ZIS["Q" D AQUE
-	W:'$D(IOP) !
-	I '$D(IO("Q")),'POP,%ZISB,%ZIS'["T" D O^%ZIS4
-	G Q
-DEVOK	N X,Y,X1 ;Not sure this is needed
-	S X=IO,X1=%ZTYPE
-	D DEVOK^%ZOSV I Y=-99!(Y=0)!(Y=$J) Q
-	I Y>0 S POP=1 W:'$D(IOP)&('$D(%ZISHG(0))!(%IS["D")) !,$C(7),"[Device Unavailable]" Q
-	I Y=-1 S IO="",POP=1 W:'$D(IOP)&('$D(ZISHG(0))!(%IS["D")) !,$C(7),"[Device does not Exist or Unavailable]" Q
-	Q
-	;
-MARGN	;Get the margin and page length
-	S %A=$P(%Y,";",1)
-	I %A?1A.ANP D SUBIEN(.%A,1) I $D(^%ZIS(2,%A,1)) K %Z91 D ST(1) S %Y=$P(%Y,";",2,9),%ZISMY=$P(%ZISMY,";",2,9) G MARGN
-	I %A>3 S $P(%Z91,"^")=$S(%A>255:255,1:+%A)
-	I $P(%Y,";",2) S $P(%Z91,"^",3)=+$S($P(%Y,";",2)>65530:65530,1:$P(%Y,";",2)) ;Cache fix for $Y#65535 wrap
-	;
-ALTP	I '$D(IO("P")) Q:%A>3  G ASKMAR:%ZTYPE["TRM" Q
-	S %X=$F(IO("P"),"M") I %X S %A=+$E(IO("P"),%X,99),$P(%Z91,"^")=$S(%A>255:255,1:%A)
-	S %X=$F(IO("P"),"L") I %X S $P(%Z91,"^",3)=+$E(IO("P"),%X,99)
-	Q:%A>3!(%ZTYPE'["TRM")
-ASKMAR	I %IS["M",'$D(IOP),$S(%E=%H:+$P(%Z,"^",3),1:1),$P(%Z,"^",4) W "    Right Margin: " W:$P(%Z91,"^")]"" +%Z91,"// "
-	E  Q
-	D SBR^%ZIS1 I '$D(DTOUT)&'$D(DUOUT) S:%X=""&($P(%Z91,"^")]"") %X=+%Z91 G ASKMAR:%X'?1.N S $P(%Z91,"^")=$S(%X>255:255,1:%X) Q
-	S POP=1 I %ZISB&(%ZTYPE["TRM")&(IO'=IO(0)) C IO K IO(1,IO) Q
-	Q
-SETPAR	S:$L(%ZISOPAR)&($E(%ZISOPAR)'="(") %ZISOPAR="("_%ZISOPAR_")"
-	Q
-AQUE	;Ask about Queueing
-	W ! S %=$S($D(IO("Q")):1,1:2),U="^",%ZISDTIM=60
-	I $D(IO("Q")) W !,"Previously, you have selected queueing."
-	W !,"Do you "_$S($D(IO("Q")):"STILL ",1:"")_"want your output QUEUED"
-	D YN^%ZIS1 K %ZISDTIM G AQUE:%=0 Q:$D(IO("Q"))
-	I %=-1 S POP=1,%ZISHPOP=1,%ZISUOUT=1 C IO K IO(1,IO) Q
-	I %=1 S IO("Q")=1 C IO K IO(1,IO) Q
-	;I %=2 K IO("Q")
-	Q
-ST(%ZISTP)	;
-	S %ZISIOST(0)=%A,%ZISIOST=$P($G(^%ZIS(2,%A,0)),"^")
-	S:'$D(%Z91) %Z91=$P($G(^%ZIS(2,%A,1),"132^#^60^$C(8)"),"^",1,4),$P(%Z91,"^",5)=$G(^("XY"))
-	Q:%ZISTP
-STP	N %B ;%E is a pointer to the Device file
-	S %B=$G(^%ZIS(1,%E,91))
-	S:$P(%B,"^")]"" $P(%Z91,"^")=+%B S:$P(%B,"^",3)]"" $P(%Z91,"^",3)=$P(%B,"^",3) ;S $P(%Z91,"^",5)=$G(^%ZIS(2,%ZISIOST(0),"XY"))
-	Q
-SUBIEN(%1,%)	;Return Subtype ien. %1 is call by Ref.
-	N %XX,%YY
-	I $D(^%ZIS(2,"B",%1))>9 S %1=+$O(^%ZIS(2,"B",%1,0)) Q
-	I '$G(%) S X="" Q
-	S %XX=%1 D 2^%ZIS5 S %1=+%YY
-	Q
-SUBTYPE(%A)	;Called from %ZISH
-	N %ZISIOST,%Z91
-	S:$G(%A)="" %A="P-OTHER"
-	D SUBIEN(.%A),ST(1)
-	S IOM=$P(%Z91,U,1),IOF=$P(%Z91,U,2),IOSL=$P(%Z91,U,3),IOST=%ZISIOST,IOST(0)=%ZISIOST(0),IOBS="$C(8)"
-	S:IOST="" IOST="P-OTHER",IOST(0)=0
-	Q
+%ZIS3 ;SFISC/AC,RWF -- DEVICE HANDLER(DEVICE TYPES & PARAMETERS) ;10/06/2005  13:23
+ ;;8.0;KERNEL;**18,36,69,104,391**;JUL 10, 1995
+ I %ZIS'["T",$G(^%ZIS(1,+%E,"POX"))]"" D XPOX^ZISX(%E)
+ I $D(%ZISQUIT) S POP=1 K %ZISQUIT
+ S %ZISCHK=1
+ I 'POP&(%ZISB)&(%ZTYPE'="RES")&(%ZTYPE'="OTH")&(%ZTYPE'="SDP")&(IO'["::") D DEVOK
+ G Q:POP
+ G @%ZTYPE:(%ZTYPE["TRM"),@(%ZTYPE_"^%ZIS6") ;Jump to next part
+ ; 
+Q I $D(%ZISUOUT) K %ZISUOUT,%ZISHP,%ZISHPOP Q
+ I $D(%ZISHPOP)&$S(IO="":1,1:'$D(IO(1,IO))) D HGBSY^%ZIS2 Q
+ I POP S:%IS'["T" IO="" I $D(%ZISHG(0)),%IS'["D",'$D(%ZISHPOP) G HUNT^%ZIS2
+ Q
+VTRM ;Virtual terminal type
+TRM D OPEN^%ZIS4:'POP&(%ZISB&(%IS'["T")),MARGN:'POP,SETPAR:'POP ;Terminal type
+ I 'POP,%IS'["T",%ZISB=1,'$D(IOP),IO'=IO(0),'$D(IO("Q")),%IS["Q" D AQUE
+ W:'$D(IOP) ! I '$D(IO("Q")) D O^%ZIS4:'POP&(%ZISB&(%IS'["T"))
+ G Q
+DEVOK N X,Y,X1
+ S X=IO,X1=%ZTYPE
+ D DEVOK^%ZOSV I Y=-99!(Y=0)!(Y=$J) Q
+ I Y>0 S POP=1 W:'$D(IOP)&('$D(%ZISHG(0))!(%IS["D")) !,*7,"[Device Unavailable]" Q
+ I Y=-1 S IO="",POP=1 W:'$D(IOP)&('$D(ZISHG(0))!(%IS["D")) !,*7,"[Device does not Exist or Unavailable]" Q
+ Q
+ ;
+MARGN ;Get the margin and page length
+ S %A=$P(%Y,";",1)
+ I %A?1A.ANP D SUBIEN(.%A,1) I $D(^%ZIS(2,%A,1)) K %Z91 D ST(1) S %Y=$P(%Y,";",2,9),%ZISMY=$P(%ZISMY,";",2,9) G MARGN
+ I %A>3 S $P(%Z91,"^")=$S(%A>255:255,1:+%A)
+ I $P(%Y,";",2) S $P(%Z91,"^",3)=+$S($P(%Y,";",2)>65530:65530,1:$P(%Y,";",2)) ;Cache fix for $Y#65535 wrap
+ ;
+ALTP I '$D(IO("P")) Q:%A>3  G ASKMAR:%ZTYPE["TRM" Q
+ S %X=$F(IO("P"),"M") I %X S %A=+$E(IO("P"),%X,99),$P(%Z91,"^")=$S(%A>255:255,1:%A)
+ S %X=$F(IO("P"),"L") I %X S $P(%Z91,"^",3)=+$E(IO("P"),%X,99)
+ Q:%A>3!(%ZTYPE'["TRM")
+ASKMAR I %IS["M",'$D(IOP),$S(%E=%H:+$P(%Z,"^",3),1:1),$P(%Z,"^",4) W "    Right Margin: " W:$P(%Z91,"^")]"" +%Z91,"// "
+ E  Q
+ D SBR^%ZIS1 I '$D(DTOUT)&'$D(DUOUT) S:%X=""&($P(%Z91,"^")]"") %X=+%Z91 G ASKMAR:%X'?1.N S $P(%Z91,"^")=$S(%X>255:255,1:%X) Q
+ S POP=1 I %ZISB&(%ZTYPE["TRM")&(IO'=IO(0)) C IO K IO(1,IO) Q
+ Q
+SETPAR S:%ZISOPAR]""&($A(%ZISOPAR)-40) %ZISOPAR="("_%ZISOPAR_")"
+ Q
+AQUE W ! S %=$S($D(IO("Q")):1,1:2),U="^",%ZISDTIM=60
+ I $D(IO("Q")) W !,"Previously, you have selected queueing."
+ W !,"Do you "_$S($D(IO("Q")):"STILL ",1:"")_"want your output QUEUED"
+ D YN^%ZIS1 K %ZISDTIM G AQUE:%=0 Q:$D(IO("Q"))
+ I %=-1 S POP=1,%ZISHPOP=1,%ZISUOUT=1 C IO K IO(1,IO) Q
+ I %=1 S IO("Q")=1 C IO K IO(1,IO) Q
+ Q
+ST(%ZISTP) ;
+ S %ZISIOST(0)=%A,%ZISIOST=$P($G(^%ZIS(2,%A,0)),"^")
+ S:'$D(%Z91) %Z91=$P($G(^%ZIS(2,%A,1),"132^#^60^$C(8)"),"^",1,4),$P(%Z91,"^",5)=$G(^("XY"))
+ Q:%ZISTP
+STP N %B ;%E is a pointer to the Device file
+ S %B=$G(^%ZIS(1,%E,91))
+ S:$P(%B,"^")]"" $P(%Z91,"^")=+%B S:$P(%B,"^",3)]"" $P(%Z91,"^",3)=$P(%B,"^",3) ;S $P(%Z91,"^",5)=$G(^%ZIS(2,%ZISIOST(0),"XY"))
+ Q
+SUBIEN(%1,%) ;Return Subtype ien. %1 is call by Ref.
+ N %XX,%YY
+ I $D(^%ZIS(2,"B",%1))>9 S %1=+$O(^%ZIS(2,"B",%1,0)) Q
+ I '$G(%) S X="" Q
+ S %XX=%1 D 2^%ZIS5 S %1=+%YY
+ Q
+SUBTYPE(%A) ;Called from %ZISH
+ N %ZISIOST,%Z91
+ S:$G(%A)="" %A="P-OTHER"
+ D SUBIEN(.%A),ST(1)
+ S IOM=$P(%Z91,U,1),IOF=$P(%Z91,U,2),IOSL=$P(%Z91,U,3),IOST=%ZISIOST,IOST(0)=%ZISIOST(0),IOBS="$C(8)"
+ S:IOST="" IOST="P-OTHER",IOST(0)=0
+ Q
+ 
Index: WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/ZIS4GTM.m
===================================================================
--- WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/ZIS4GTM.m	(revision 613)
+++ WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/ZIS4GTM.m	(revision 623)
@@ -1,109 +1,103 @@
-%ZIS4	;ISF/RWF,DW - DEVICE HANDLER SPECIFIC CODE (GT.M for Unix/VMS) ;1/24/08  16:08
-	;;8.0;KERNEL;**275,425,440**;Jul 10, 1995;Build 13
-	;Per VHA Directive 2004-038, this routine should not be modified
-OPEN	;From %ZIS3 for TRM
-	G OPN2:$D(IO(1,IO))
-	S POP=0 D OP1 G NOPEN:'$D(IO(1,IO))
-OPN2	;
-	I $D(%ZISHP),'$D(IOP) W !,*7," Routing to device "_$P(^%ZIS(1,%E,0),"^",1)_$S($D(^(1)):" "_$P(^(1),"^",1)_" ",1:"")
-	Q
-NOPEN	I %IS'["D",$D(%ZISHP)!(%ZISHG]"") S POP=1 Q
-	I '$D(IOP) W *7,"  [BUSY]" W "  ...  RETRY" S %=2,U="^" D YN^%ZIS1 G OPEN:%=1
-	S POP=1 Q
-	Q
-	;Why no open paraneters???
-OP1	N $ET S $ET="G OPNERR^%ZIS4"
-	I $D(%ZISLOCK) L +@%ZISLOCK:5 E  S POP=1 Q
-	O IO::%ZISTO S:$T IO(1,IO)="" S:'$T POP=1
-	Q
-OPNERR	;Open Error
-	S POP=1,IO("LASTERR")=$G(IO("ERROR")),IO("ERROR")=$$EC^%ZOSV,$EC=""
-	Q
-	;
-O	;From %ZIS6 for all types.
-	D:%IS["L" ZIO
-	I $D(IO("S")),$D(^%ZIS(2,IO("S"),10)),^(10)]"" U IO(0) D X10^ZISX ;Open Printer Port
-OPAR	I $D(IOP),%ZTYPE="HFS",$D(%IS("HFSIO")),$D(%IS("IOPAR")),%IS("HFSIO")]"" S IO=%IS("HFSIO"),%ZISOPAR=%IS("IOPAR")
-	I %ZTYPE="CHAN" D TCPIP Q:POP  G OXECUTE^%ZIS6
-	S %A=%ZISOPAR_$S(%ZISOPAR["):":"",1:":"_%ZISTO)
-	N % S %(IO)="",%=$P($P($NA(%(IO)),"(",2),")")
-	S %A=%_$E(":",%A]"")_%A
-	D O1 I POP D  Q
-	.I %ZTYPE="HFS",'$D(IOP),$G(IO("ERROR"))["file not found" W !,?5,*7,"[File Not Found]" Q
-	.W:'$D(IOP) !,?5,*7,"[DEVICE IS BUSY]" Q
-	;S IO(1,IO)="" U IO S:'(IO=IO(0)&'$D(IO("S"))&'$D(ZTQUEUED)) $X=0,$Y=0 I %ZTYPE["TRM" U IO:(WIDTH=+%Z91)
-	U IO S $X=0,$Y=0 I %ZTYPE["TRM" U IO:(WIDTH=+%Z91)
-	I %ZISUPAR]"" S %A1=""""_IO_""":"_%ZISUPAR U @%A1
-	;U:%IS'[0 IO(0)
-	G OXECUTE^%ZIS6
-	;
-O1	N $ES,$ET S $ET="G OPNERR^%ZIS4"
-	I $D(%ZISLOCK) L +@%ZISLOCK:5 E  S POP=1 Q
-	O @%A S:'$T&(%A?.E1":".N) POP=1 S:'POP IO(1,IO)=""
-	S IO("ERROR")="" Q
-	;
-	;Need to find out how to get IP address
-ZIO	N %,%1 S (%,%1)=$ZIO
-	I $ZV["VMS",%["_TNA" D
-	. S (%,%1)=$ZGETDVI($I,"TT_ACCPORNAM")
-	. S %=$S(%["Host:":$P($P(%,"Host: ",2)," ")_":"_$P(%,"Port: ",2),1:%) S:%[" " %=$TR(%," ")
-	I $ZV'["VMS" D
-	. S (%,%1)=$ZTRNLNM("REMOTEHOST") S:$L(%) %1="Host:"_% S:'$L(%) %=$ZIO
-	S IO("ZIO")=% S:(%1["Host:")&'$D(IO("IP")) IO("IP")=$P(%,":")
-	Q
-	;
-TCPIP	;For TCP/IP devices, should use ^%ZISTCP
-	N %S
-	S %ZISTO=$G(%ZISTO,3)
-	S %A="IO:"_$S($E(%ZISOPAR)="(":"",1:"(")_%ZISOPAR_$S($E(%ZISOPAR,$L(%ZISOPAR))=")":"",1:")")_":%ZISTO:""SOCKET"""
-	;U $P W !,"%A=",%A
-	O @%A I '$T S POP=1 Q  ;D O1 ;Do the open.
-	U IO:(WIDTH=512:NOWRAP:EXCEPT="G OPNERR^%ZIS4") S %S=$KEY
-	U $P ;W !,"$KEY=",%S
-	Q
-	;
-SPOOL	;%ZDA=pointer to ^XMB(3.51, %ZFN=spool file name.
-	I $D(ZISDA) W:'$D(IOP) !?5,*7,"You may not Spool the printing of a Spool document" G N
-	I $D(DUZ)[0 W:'$D(IOP) !,"Must be a valid user." G N
-R	S %ZY=-1 D NEWDOC^ZISPL1 G N:%ZY'>0
-	S %ZDA=+%ZY,%ZFN=$P(%ZY(0),U,2),IO("DOC")=$P(%ZY(0),U,1) G OK:$D(IO("Q"))
-	G:'%ZISB OK I '$P(%ZY,"^",3),$L(%ZFN) O %ZFN:(append:nowrap):2 G DOC
-	S %ZFN=IO_"SPOOL_no_"_%ZDA_".TMP" D SPL2 G:%ZFN']"" N S $P(^XMB(3.51,%ZDA,0),U,2)=%ZFN,^XMB(3.51,"C",%ZFN,%ZDA)=""
-DOC	S IO=%ZFN,IO("SPOOL")=%ZDA,^XUTL("XQ",$J,"SPOOL")=%ZDA,IOF="#"
-	I $D(^%ZIS(1,%ZISIOS,1)),$P(^(1),"^",8),$O(^("SPL",0)) S ^XUTL("XQ",$J,"ADSPL")=%ZISIOS,ZISPLAD=%ZISIOS
-OK	K %ZDA,%ZFN Q
-N	K %ZDA,%ZFN,IO("DOC") S POP=1 Q
-	;
-SPL2	;Open for write
-	O %ZFN:(newversion:noreadonly:nowrap:exception="G SPL4"):2 G:$ZA<0 SPL4 S IO(1,%ZFN)="" Q
-	;
-SPL3	;Open for Read
-	O %ZFN:(readonly:exception="G SPL4"):2 S:'$T ZISPLQ=1 G:'$T SPL4 S IO(1,%ZFN)="" Q
-SPL4	W:'$D(IOP)&'$D(ZTQUEUED) !?5,*7,"Couldn't open the spool file." S %ZFN="" Q
-	;
-CLOSE	;Close out the spool
-	N %,%1,%Z1,%ZFN,%ZS,%ZDA,XS,%Y,%X
-	I $L(IO) C IO K IO(1,IO)
-	D FILE^ZISPL1 I %ZDA'>0 K ZISPLAD Q
-	S %ZFN=$P(%ZS,"^",2) D SPL3 Q:%ZFN']""  S %ZCR=$C(13),%Y=""
-	S %Z1=+$G(^XTV(8989.3,1,"SPL")),%=0
-	U %ZFN F  R %X#255:5 Q:$ZEOF  S %2=%X D CL2 Q:%Z1<%
-SPLEX	C %ZFN:(DELETE) K:%ZFN]"" IO(1,%ZFN) D CLOSE^ZISPL1 K %Y,%X,%1,%ZFN Q
-	;
-CL2	S %=%+1 I %Z1<% S ^XMBS(3.519,XS,2,%,0)="*** INCOMPLETE REPORT  -- SPOOL DOCUMENT LINE LIMIT EXCEEDED ***",$P(^XMB(3.51,%ZDA,0),"^",11)=1 Q
-	I %2[$C(12) S ^XMBS(3.519,XS,2,%,0)="|TOP|" Q
-	S ^XMBS(3.519,XS,2,%,0)=%2 Q
-	;
-HFS	G HFS^%ZISF
-REWMT(IO,IOPAR)	;Rewind Magtape
-	S X="REWERR^%ZIS4",@^%ZOSF("TRAP")
-	U IO W *5
-	Q 1
-REWSDP(IO,IOPAR)	;Rewind SDP
-	G REW1
-REWHFS(IO,IOPAR)	;Rewind Host File.
-REW1	S X="REWERR^%ZIS4",@^%ZOSF("TRAP")
-	U IO:(REWIND)
-	Q 1
-REWERR	;Error encountered
-	Q 0
+%ZIS4 ;ISF/RWF,DW - DEVICE HANDLER SPECIFIC CODE (GT.M for Unix/VMS) ;03/07/2007
+ ;;8.0;KERNEL;**275,425**;Jul 10, 1995;Build 18
+ ;
+OPEN ;From %ZIS3 for TRM
+ G OPN2:$D(IO(1,IO))
+ S POP=0 D OP1 G NOPEN:'$D(IO(1,IO))
+OPN2 ;
+ I $D(%ZISHP),'$D(IOP) W !,*7," Routing to device "_$P(^%ZIS(1,%E,0),"^",1)_$S($D(^(1)):" "_$P(^(1),"^",1)_" ",1:"")
+ Q
+NOPEN I %IS'["D",$D(%ZISHP)!(%ZISHG]"") S POP=1 Q
+ I '$D(IOP) W *7,"  [BUSY]" W "  ...  RETRY" S %=2,U="^" D YN^%ZIS1 G OPEN:%=1
+ S POP=1 Q
+ Q
+ ;Why no open paraneters???
+OP1 N $ES,$ET S $ET="G OPNERR^%ZIS4"
+ L:$D(%ZISLOCK) +@%ZISLOCK:60
+ O IO::%ZISTO S:$T IO(1,IO)="" S:'$T POP=1 L:$D(%ZISLOCK) -@%ZISLOCK
+ Q
+OPNERR ;Open Error
+ S POP=1,IO("LASTERR")=$G(IO("ERROR")),IO("ERROR")=$$EC^%ZOSV,$EC="" Q
+ ;
+O ;From %ZIS6 for other types.
+ D:%IS["L" ZIO
+LCKGBL ;Lock Global
+ I %ZTYPE="CHAN" N % S %=$G(^%ZIS(1,+%E,"GBL")) I $L(%) L @("+^"_%_":0") S:'$T POP=1 I POP W:'$D(IOP) !,?5,*7,"[DEVICE IS BUSY]" Q
+ I $D(IO("S")),$D(^%ZIS(2,IO("S"),10)),^(10)]"" U IO(0) D X10^ZISX
+OPAR I $D(IOP),%ZTYPE="HFS",$D(%IS("HFSIO")),$D(%IS("IOPAR")),%IS("HFSIO")]"" S IO=%IS("HFSIO"),%ZISOPAR=%IS("IOPAR")
+ I %ZTYPE="CHAN" D TCPIP Q:POP  G OXECUTE^%ZIS6
+ S %A=%ZISOPAR_$S(%ZISOPAR["):":"",%ZTYPE["CHAN"&($P(%ZTIME,"^",3)="n"):"",1:":"_%ZISTO)
+ N % S %(IO)="",%=$P($P($NA(%(IO)),"(",2),")")
+ S %A=%_$E(":",%A]"")_%A
+ D O1 I POP D  Q
+ .I %ZTYPE="HFS",'$D(IOP),$G(IO("ERROR"))["file not found" W !,?5,*7,"[File Not Found]" Q
+ .W:'$D(IOP) !,?5,*7,"[DEVICE IS BUSY]" Q
+ ;S IO(1,IO)="" U IO S:'(IO=IO(0)&'$D(IO("S"))&'$D(ZTQUEUED)) $X=0,$Y=0 I %ZTYPE["TRM" U IO:(WIDTH=+%Z91)
+ U IO S $X=0,$Y=0 I %ZTYPE["TRM" U IO:(WIDTH=+%Z91)
+ I %ZISUPAR]"" S %A1=""""_IO_""":"_%ZISUPAR U @%A1
+ ;U:%IS'[0 IO(0)
+ G OXECUTE^%ZIS6
+ ;
+O1 N $ES,$ET S $ET="G OPNERR^%ZIS4"
+ L:$D(%ZISLOCK) +@%ZISLOCK:60
+ O @%A S:'$T&(%A?.E1":".N) POP=1 S:'POP IO(1,IO)="" L:$D(%ZISLOCK) -@%ZISLOCK
+ S IO("ERROR")="" Q
+ ;
+ ;Need to find out how to get IP address
+ZIO N %,%1 S (%,%1)=$ZIO
+ I $ZV["VMS",%["_TNA" D
+ . S (%,%1)=$ZGETDVI($I,"TT_ACCPORNAM")
+ . S %=$S(%["Host:":$P($P(%,"Host: ",2)," ")_":"_$P(%,"Port: ",2),1:%) S:%[" " %=$TR(%," ")
+ I $ZV'["VMS" D
+ . S (%,%1)=$ZTRNLNM("REMOTEHOST") S:$L(%) %1="Host:"_% S:'$L(%) %=$ZIO
+ S IO("ZIO")=% S:(%1["Host:")&'$D(IO("IP")) IO("IP")=$P(%,":")
+ Q
+ ;
+TCPIP ;For TCP/IP devices
+ N %S
+ S %ZISTO=$G(%ZISTO,3)
+ S %A="IO:"_$S($E(%ZISOPAR)="(":"",1:"(")_%ZISOPAR_$S($E(%ZISOPAR,$L(%ZISOPAR))=")":"",1:")")_":%ZISTO:""SOCKET"""
+ ;U $P W !,"%A=",%A
+ O @%A I '$T S POP=1 Q  ;D O1 ;Do the open.
+ U IO:(WIDTH=512:NOWRAP:EXCEPT="G OPNERR^%ZIS4") S %S=$KEY
+ U $P ;W !,"$KEY=",%S
+ Q
+ ;
+SPOOL ;%ZDA=pointer to ^XMB(3.51, %ZFN=spool file name.
+ I $D(ZISDA) W:'$D(IOP) !?5,*7,"You may not Spool the printing of a Spool document" G N
+ I $D(DUZ)[0 W:'$D(IOP) !,"Must be a valid user." G N
+R S %ZY=-1 D NEWDOC^ZISPL1 G N:%ZY'>0 S %ZDA=+%ZY,%ZFN=$P(%ZY(0),U,2),IO("DOC")=$P(%ZY(0),U,1) G OK:$D(IO("Q"))
+ G:'%ZISB OK I '$P(%ZY,"^",3),%ZFN]"" D SPL3 G N:%ZFN']"",DOC
+ S %ZFN=IO_"SPOOL_no_"_%ZDA_".TMP" D SPL2 G:%ZFN']"" N S $P(^XMB(3.51,%ZDA,0),U,2)=%ZFN,^XMB(3.51,"C",%ZFN,%ZDA)=""
+DOC S IO=%ZFN,IO("SPOOL")=%ZDA,^XUTL("XQ",$J,"SPOOL")=%ZDA,IOF="#"
+ I $D(^%ZIS(1,%ZISIOS,1)),$P(^(1),"^",8),$O(^("SPL",0)) S ^XUTL("XQ",$J,"ADSPL")=%ZISIOS,ZISPLAD=%ZISIOS
+OK K %ZDA,%ZFN Q
+N K %ZDA,%ZFN,IO("DOC") S POP=1 Q
+SPL2 O %ZFN:(NEWVERSION:WORLD=RWD) G:$ZA<0 SPL4 S IO(1,%ZFN)="" Q
+SPL3 N X S X="SPL4^%ZIS4",@^%ZOSF("TRAP")
+ O %ZFN:READONLY:1 S:'$T ZISPLQ=1 G:$ZA<0!('$T) SPL4 S IO(1,%ZFN)="" Q
+SPL4 W:'$D(IOP)&'$D(ZTQUEUED) !?5,*7,"Couldn't open the spool file." S %ZFN="" Q
+CLOSE N %Z1 C:IO]"" IO K:IO]"" IO(1,IO) D FILE^ZISPL1 I %ZDA'>0 K ZISPLAD Q
+ S %ZFN=$P(%ZS,"^",2) D SPL3 Q:%ZFN']""  U %ZFN S %ZCR=$C(13),%Y="",X="SPLEOF^%ZIS4",@^%ZOSF("TRAP")
+ S %Z1=+$G(^XTV(8989.3,1,"SPL"))
+ F %=0:0 R %X#255:5 Q:$ZA<0  S %2=%X D CL2 G:%Z1<% SPLEX
+SPLEOF I $ZE'["ENDO" Q  ;Send error up
+SPLEX C %ZFN:(DELETE) K:%ZFN]"" IO(1,%ZFN) D CLOSE^ZISPL1 K %Y,%X,%1,%ZFN Q
+ ;
+CL2 S %=%+1 I %Z1<% S ^XMBS(3.519,XS,2,%,0)="*** INCOMPLETE REPORT  -- SPOOL DOCUMENT LINE LIMIT EXCEEDED ***",$P(^XMB(3.51,%ZDA,0),"^",11)=1 Q
+ I %2[$C(12) S ^XMBS(3.519,XS,2,%,0)="|TOP|" Q
+ S ^XMBS(3.519,XS,2,%,0)=%2 Q
+ ;
+HFS G HFS^%ZISF
+REWMT(IO,IOPAR) ;Rewind Magtape
+ S X="REWERR^%ZIS4",@^%ZOSF("TRAP")
+ U IO W *5
+ Q 1
+REWSDP(IO,IOPAR) ;Rewind SDP
+ G REW1
+REWHFS(IO,IOPAR) ;Rewind Host File.
+REW1 S X="REWERR^%ZIS4",@^%ZOSF("TRAP")
+ U IO:(REWIND)
+ Q 1
+REWERR ;Error encountered
+ Q 0
Index: WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/ZIS4ONT.m
===================================================================
--- WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/ZIS4ONT.m	(revision 613)
+++ WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/ZIS4ONT.m	(revision 623)
@@ -1,131 +1,127 @@
-%ZIS4	;SFISC/RWF,AC - DEVICE HANDLER SPOOL SPECIFIC CODE (Cache) ;1/24/08  16:08
-	;;8.0;KERNEL;**34,59,69,191,278,293,440**;Jul 10, 1995;Build 13
-	;Per VHA Directive 2004-038, this routine should not be modified
-OPEN	;Called for TRM devices
-	G OPN2:$D(IO(1,IO))
-	S POP=0 D OP1 G NOPEN:'$D(IO(1,IO))
-OPN2	;
-	I $D(%ZISHP),'$D(IOP) W !,$C(7)_" Routing to device "_$P(^%ZIS(1,%E,0),"^",1)_$S($D(^(1)):" "_$P(^(1),"^",1)_" ",1:"")
-	Q
-NOPEN	;
-	I %IS'["D",$D(%ZISHP)!(%ZISHG]"") S POP=1 Q
-	I '$D(IOP) W $C(7)_"  [BUSY]" W "  ...  RETRY" S %=2,U="^" D YN^%ZIS1 G OPEN:%=1
-	S POP=1 Q
-	Q
-OP1	N $ET S $ET="G OPNERR^%ZIS4"
-	I $D(%ZISLOCK) L +@%ZISLOCK:5 E  S POP=1 Q
-	O IO::%ZISTO S:$T IO(1,IO)="" S:'$T POP=1
-	Q
-OPNERR	S POP=1,IO("LASTERR")=$G(IO("ERROR")),IO("ERROR")=$ZE,$EC=""
-	Q
-	;
-O	;Gets called for all devices
-	N X,%A1
-	D:%ZIS["L" ZIO
-	I $D(IO("S")),$D(^%ZIS(2,IO("S"),10)),^(10)]"" U IO(0) D X10^ZISX ;Open Printer port
-OPAR	I $D(IOP),%ZTYPE="HFS",$D(%ZIS("HFSIO")),$D(%ZIS("IOPAR")),%ZIS("HFSIO")]"" S IO=%ZIS("HFSIO"),%ZISOPAR=%ZIS("IOPAR")
-	S %A=$S($L(%ZISOPAR):%ZISOPAR,%ZTYPE'["TRM":"",$E(%ZISIOST,1)="C":"("_+%Z91_":""C"")",$E(%ZISIOST,1,2)="PK":"("_+%Z91_":""P"")",1:+%Z91)
-	S %A=%A_$S(%A["):":"",%ZTYPE["OTH"&($P(%ZTIME,"^",3)="n"):"",1:":"_%ZISTO),%A=""""_IO_""""_$E(":",%A]"")_%A
-	D O1 I POP W:'$D(IOP) !,?5,$C(7)_"[Device is BUSY]" Q
-	;I %ZTYPE="HFS" U IO S X=IO,IO=IO_";"_$P($ZIO,";",2),IO(1,IO)="" K IO(1,X)
-	U IO S $X=0,$Y=0
-	I $L(%ZISUPAR) S %A1=""""_IO_""":"_%ZISUPAR U @%A1
-	;U:%IS'[0 IO(0)
-	G OXECUTE^%ZIS6
-	;
-O1	N $ET S $ET="G OPNERR^%ZIS4"
-	I $D(%ZISLOCK) L +@%ZISLOCK:5 E  S POP=1 Q
-	O @%A S:'$T&(%A?.E1":".N) POP=1 S:'POP IO(1,IO)=""
-	S IO("ERROR")=""
-	Q
-	;Version 3 used ip/port, Version 4 has ip:port|xx
-ZIO	N %,%1 S %=$ZIO,%1=$$VERSION^%ZOSV
-	S IO("ZIO")=$S(%1<4:$I,1:$ZIO),%1=$S(%["/":"/",1:":")
-	;Drop prefix
-	S:%["|TNT|" %=$E(%,6,999) S:%["|TNA|" %=$E(%,6,999)
-	;Get IP name or number
-	I '$D(IO("IP")) D
-	. S:$P(%,%1)["." IO("IP")=$P(%,%1)
-	Q
-	;
-SPOOL	;%ZDA=pointer to ^XMB(3.51, %ZFN=spool file Num/Name.
-	N %ZOS S %ZOS=$$OS^%ZOSV
-	I '$D(^XMB(3.51,0)) W:'$D(IOP) !?5,"The spooler files are not setup in this account." G NO
-	I $D(ZISDA) W:'$D(IOP) !?5,$C(7)_"You may not Spool the printing of a Spool document" G NO
-	I $D(DUZ)[0 W:'$D(IOP) !,"Must be a valid user." G NO
-	;Get entry in Spool Doc file
-R	S %ZY=-1 D NEWDOC^ZISPL1:$D(DUZ)=11 G NO:%ZY'>0 S %ZDA=+%ZY,%ZFN=$P(%ZY(0),U,2),IO("DOC")=$P(%ZY(0),U,1) G OK:$D(IO("Q"))
-	G:'%ZISB OK I '$P(%ZY,"^",3),%ZFN]"" D SPL3 G NO:%ZFN<0,DOC
-	I %ZOS="NT" D  G:%ZFN>255 NO
-	. F %ZFN=1:1:260 I '$D(^XMB(3.51,"C",%ZFN))!$D(^(%ZFN,%ZDA)) Q:%ZFN<256  W:'$D(IOP) $C(7)_"  DELETE SOME OTHER DOCUMENT!" Q
-	. Q:%ZFN>255  D SPL2 S $P(^XMB(3.51,%ZDA,0),U,2)=%ZFN,^XMB(3.51,"C",%ZFN,%ZDA)=""
-	I %ZOS="VMS" D  G:%ZFN=-1 NO
-	. S %ZFN=IO_"SPOOL_no_"_%ZDA_".TMP" D SPL2 Q:%ZFN=-1  S $P(^XMB(3.51,%ZDA,0),U,2)=%ZFN,^XMB(3.51,"C",%ZFN,%ZDA)="",IO=%ZFN
-DOC	S IO("SPOOL")=%ZDA,^XUTL("XQ",$J,"SPOOL")=%ZDA
-	I $D(^%ZIS(1,%ZISIOS,1)),$P(^(1),"^",8),$O(^("SPL",0)) S ^XUTL("XQ",$J,"ADSPL")=%ZISIOS,ZISPLAD=%ZISIOS
-OK	K %ZDA,%ZFN Q
-NO	K %ZDA,%ZFN,IO("DOC") S POP=1 Q
-	;
-SPL2	I %ZOS="NT" O IO:(%ZFN:0) S IO(1,IO)="",^SPOOL(0,IO("DOC"),%ZFN)="",^SPOOL(%ZFN,0)=IO("DOC")_"{"_$H Q
-	;VMS
-	O %ZFN:("WNS"):2 G:'$T SPL4 S IO(1,%ZFN)="" Q
-	;
-SPL3	I %ZOS="NT" G SPL4:'$D(^SPOOL(%ZFN,2147483647)) O IO:(%ZFN:$P(^(2147483647),"{",3)):1 S:'$T ZISPLQ=1 K ^(2147483647) S IO(1,IO)="" Q
-	;VMS
-	N $ETRAP S $ETRAP="S $EC="""" G SPL4^%ZIS4"
-	O %ZFN:"RV":1 S:'$T ZISPLQ=1 G:$ZA<0!('$T) SPL4 S IO(1,%ZFN)="" Q
-	;
-SPL4	W:'$D(IOP) !,"Spool file already open" S %ZFN=-1 Q
-	;
-CLOSE	N %ZOS,%Z1,%ZCR,%2,%3,%X,%Y,ZTSK,%ZFN S %ZOS=$$OS^%ZOSV
-	I %ZOS="NT",IO=2,$D(IO(1,IO)) K IO(1,IO) C IO
-	I %ZOS="VMS",IO]"",$D(IO(1,IO)) U IO S %ZFN=$ZIO C IO K IO(1,IO)
-	;See that ZTSK is set so we will move to the global now.
-	S ZTSK=$G(ZTSK,1) D FILE^ZISPL1 I %ZDA'>0 K ZISPLAD Q
-	G:%ZOS="VMS" CLVMS
-	S %ZFN=$P(%ZS,"^",2),%ZCR=$C(13),%Y="",%=0,%3=$P(^SPOOL(%ZFN,2147483647),"{",3)
-	S %Z1=+$G(^XTV(8989.3,1,"SPL"))
-	F %2=1:1:%3 Q:'$D(^SPOOL(%ZFN,%2))  S %X=^SPOOL(%ZFN,%2) D
-	. I %Z1<% D LIMIT S %2=%3 Q
-	. I %X[$C(13,12) D:$L($P(%X,$C(13))) ADD($P(%X,$C(13))) D ADD("|TOP|") Q
-	. D ADD($P(%X,$C(13),1))
-	K ^SPOOL(%ZFN),^SPOOL(0,$P(%ZS,U,1)),%Y,%X,%1,%2,%3 D CLOSE^ZISPL1
-	Q
-ADD(L)	S %=%+1,^XMBS(3.519,XS,2,%,0)=L Q
-LIMIT	D ADD("*** INCOMPLETE REPORT  -- SPOOL DOCUMENT LINE LIMIT EXCEEDED ***") S $P(^XMB(3.51,%ZDA,0),"^",11)=1
-	Q
-CLVMS	;Close for Cache VMS
-	N $ES,$ET S $ET="D:$EC'[""ENDOF"" ^%ZTER,UNWIND^%ZTER S $EC="""" D SPLEX^%ZIS4,UNWIND^%ZTER"
-	S %ZA=$ZU(68,40,1) ;Work like DSM
-	;%ZFN Could be set at the top
-	S %ZFN=$S($G(%ZFN)]"":%ZFN,1:$P(%ZS,"^",2)) D SPL3 Q:%ZFN']""  U %ZFN S %ZCR=$C(13),%Y=""
-	S %Z1=+$G(^XTV(8989.3,1,"SPL")),%=0
-	F  R %X#255:5 Q:$ZEOF<0  D  G:%Z1<% SPLEX
-	. I %Z1<% D LIMIT Q
-	. I %X[$C(12) D  Q
-	. . S %Y=$P(%X,$C(12)) D:$L(%Y) ADD(%Y),ADD("|TOP|")
-	. . S %Y=$P(%X,$C(12),2) D:$L(%Y) ADD(%Y)
-	. . Q
-	. D ADD(%X)
-	. Q
-SPLEX	C %ZFN:"D" K:%ZFN]"" IO(1,%ZFN) D CLOSE^ZISPL1 K %Y,%X,%1,%ZFN Q
-	;
-	;
-HFS	G HFS^%ZISF
-REWMT(IO2,IOPAR)	;Rewind Magtape
-	N $ETRAP S $ET="G REWERR^%ZIS4"
-	U IO2 W *5
-	Q 1
-REWSDP(IO2,IOPAR)	;Rewind SDP
-	G REW1
-REWHFS(IO2,IOPAR)	;Rewind Host File.
-REW1	;ZIS set % to the current $I so need to update % if = IO
-	N NIO,OP,$ETRAP
-	S $ET="G REWERR^%ZIS4"
-	C IO2 ;You do a rewind to read the file.
-	S OP=$S($ZV["VMS":"RV",1:"RS")
-	O IO2:(OP):1 S IO(1,IO2)=""
-	Q 1
-REWERR	;Error encountered
-	S IO("ERROR")=$EC,$ECODE=""
-	Q 0
+%ZIS4 ;SFISC/RWF,AC - DEVICE HANDLER SPOOL SPECIFIC CODE (OpenM/WNT) ;11/03/2003  17:32
+ ;;8.0;KERNEL;**34,59,69,191,278,293**;Jul 10, 1995
+ ;
+OPEN G OPN2:$D(IO(1,IO))
+ S POP=0 D OP1 G NOPEN:'$D(IO(1,IO))
+OPN2 I $D(%ZISHP),'$D(IOP) W !,$C(7)_" Routing to device "_$P(^%ZIS(1,%E,0),"^",1)_$S($D(^(1)):" "_$P(^(1),"^",1)_" ",1:"")
+ Q
+NOPEN I %IS'["D",$D(%ZISHP)!(%ZISHG]"") S POP=1 Q
+ I '$D(IOP) W $C(7)_"  [BUSY]" W "  ...  RETRY" S %=2,U="^" D YN^%ZIS1 G OPEN:%=1
+ K:%E'=%H ^XUTL("ZISPARAM",IO)
+ S POP=1 Q
+ Q
+OP1 N X S X="OPNERR^%ZIS4",@^%ZOSF("TRAP")
+ L:$D(%ZISLOCK) +@%ZISLOCK:60
+ O IO::%ZISTO S:$T IO(1,IO)="" S:'$T POP=1 L:$D(%ZISLOCK) -@%ZISLOCK
+ Q
+OPNERR S POP=1,IO("LASTERR")=$G(IO("ERROR")),IO("ERROR")=$ZE,$EC="" Q
+ ;
+O N X D:%IS["L" ZIO
+ I $D(IO("S")),$D(^%ZIS(2,IO("S"),10)),^(10)]"" U IO(0) D X10^ZISX ;Open Printer port
+OPAR I $D(IOP),%ZTYPE="HFS",$D(%IS("HFSIO")),$D(%IS("IOPAR")),%IS("HFSIO")]"" S IO=%IS("HFSIO"),%ZISOPAR=%IS("IOPAR")
+ S %A=$S(%ZISOPAR]"":%ZISOPAR,%ZTYPE'["TRM":"",%ZISIOST?1"C".E:"("_+%Z91_":""C"")",%ZISIOST?1"PK".E:"("_+%Z91_":""P"")",1:+%Z91)
+ S %A=%A_$S(%A["):":"",%ZTYPE["OTH"&($P(%ZTIME,"^",3)="n"):"",1:":"_%ZISTO),%A=""""_IO_""""_$E(":",%A]"")_%A
+ D O1 I POP W:'$D(IOP) !,?5,$C(7)_"[Device is BUSY]" Q
+ ;I %ZTYPE="HFS" U IO S X=IO,IO=IO_";"_$P($ZIO,";",2),IO(1,IO)="" K IO(1,X)
+ U IO S $X=0,$Y=0
+ I %ZISUPAR]"" S %A1=""""_IO_""":"_%ZISUPAR U @%A1
+ ;U:%IS'[0 IO(0)
+ G OXECUTE^%ZIS6
+ ;
+O1 N X S X="OPNERR^%ZIS4",@^%ZOSF("TRAP")
+ L:$D(%ZISLOCK) +@%ZISLOCK:60
+ O @%A S:'$T&(%A?.E1":".N) POP=1 S:'POP IO(1,IO)=""
+ L:$D(%ZISLOCK) -@%ZISLOCK
+ S IO("ERROR")=""
+ Q
+ ;Version 3 used ip/port, Version 4 has ip:port|xx
+ZIO N %,%1 S %=$ZIO,%1=$$VERSION^%ZOSV
+ S IO("ZIO")=$S(%1<4:$I,1:$ZIO),%1=$S(%["/":"/",1:":")
+ ;Drop prefix
+ S:%["|TNT|" %=$E(%,6,999) S:%["|TNA|" %=$E(%,6,999)
+ ;Get IP name or number
+ I '$D(IO("IP")) D
+ . S:$P(%,%1)["." IO("IP")=$P(%,%1)
+ Q
+ ;
+SPOOL ;%ZDA=pointer to ^XMB(3.51, %ZFN=spool file Num/Name.
+ N %ZOS S %ZOS=$$OS^%ZOSV
+ I '$D(^XMB(3.51,0)) W:'$D(IOP) !?5,"The spooler files are not setup in this account." G NO
+ I $D(ZISDA) W:'$D(IOP) !?5,$C(7)_"You may not Spool the printing of a Spool document" G NO
+ I $D(DUZ)[0 W:'$D(IOP) !,"Must be a valid user." G NO
+ ;Get entry in Spool Doc file
+R S %ZY=-1 D NEWDOC^ZISPL1:$D(DUZ)=11 G NO:%ZY'>0 S %ZDA=+%ZY,%ZFN=$P(%ZY(0),U,2),IO("DOC")=$P(%ZY(0),U,1) G OK:$D(IO("Q"))
+ G:'%ZISB OK I '$P(%ZY,"^",3),%ZFN]"" D SPL3 G NO:%ZFN<0,DOC
+ I %ZOS="NT" D  G:%ZFN>255 NO
+ . F %ZFN=1:1:260 I '$D(^XMB(3.51,"C",%ZFN))!$D(^(%ZFN,%ZDA)) Q:%ZFN<256  W:'$D(IOP) $C(7)_"  DELETE SOME OTHER DOCUMENT!" Q
+ . Q:%ZFN>255  D SPL2 S $P(^XMB(3.51,%ZDA,0),U,2)=%ZFN,^XMB(3.51,"C",%ZFN,%ZDA)=""
+ I %ZOS="VMS" D  G:%ZFN=-1 NO
+ . S %ZFN=IO_"SPOOL_no_"_%ZDA_".TMP" D SPL2 Q:%ZFN=-1  S $P(^XMB(3.51,%ZDA,0),U,2)=%ZFN,^XMB(3.51,"C",%ZFN,%ZDA)="",IO=%ZFN
+DOC S IO("SPOOL")=%ZDA,^XUTL("XQ",$J,"SPOOL")=%ZDA
+ I $D(^%ZIS(1,%ZISIOS,1)),$P(^(1),"^",8),$O(^("SPL",0)) S ^XUTL("XQ",$J,"ADSPL")=%ZISIOS,ZISPLAD=%ZISIOS
+OK K %ZDA,%ZFN Q
+NO K %ZDA,%ZFN,IO("DOC") S POP=1 Q
+ ;
+SPL2 I %ZOS="NT" O IO:(%ZFN:0) S IO(1,IO)="",^SPOOL(0,IO("DOC"),%ZFN)="",^SPOOL(%ZFN,0)=IO("DOC")_"{"_$H Q
+ ;VMS
+ O %ZFN:("WNS"):2 G:'$T SPL4 S IO(1,%ZFN)="" Q
+ ;
+SPL3 I %ZOS="NT" G SPL4:'$D(^SPOOL(%ZFN,2147483647)) O IO:(%ZFN:$P(^(2147483647),"{",3)):1 S:'$T ZISPLQ=1 K ^(2147483647) S IO(1,IO)="" Q
+ ;VMS
+ N $ETRAP S $ETRAP="S $EC="""" G SPL4^%ZIS4"
+ O %ZFN:"RV":1 S:'$T ZISPLQ=1 G:$ZA<0!('$T) SPL4 S IO(1,%ZFN)="" Q
+ ;
+SPL4 W:'$D(IOP) !,"Spool file already open" S %ZFN=-1 Q
+ ;
+CLOSE N %ZOS,%Z1,%ZCR,%2,%3,%X,%Y,ZTSK,%ZFN S %ZOS=$$OS^%ZOSV
+ I %ZOS="NT",IO=2,$D(IO(1,IO)) K IO(1,IO) C IO
+ I %ZOS="VMS",IO]"",$D(IO(1,IO)) U IO S %ZFN=$ZIO C IO K IO(1,IO)
+ ;See that ZTSK is set so we will move to the global now.
+ S ZTSK=$G(ZTSK,1) D FILE^ZISPL1 I %ZDA'>0 K ZISPLAD Q
+ G:%ZOS="VMS" CLVMS
+ S %ZFN=$P(%ZS,"^",2),%ZCR=$C(13),%Y="",%=0,%3=$P(^SPOOL(%ZFN,2147483647),"{",3)
+ S %Z1=+$G(^XTV(8989.3,1,"SPL"))
+ F %2=1:1:%3 Q:'$D(^SPOOL(%ZFN,%2))  S %X=^SPOOL(%ZFN,%2) D
+ . I %Z1<% D LIMIT S %2=%3 Q
+ . I %X[$C(13,12) D:$L($P(%X,$C(13))) ADD($P(%X,$C(13))) D ADD("|TOP|") Q
+ . D ADD($P(%X,$C(13),1))
+ K ^SPOOL(%ZFN),^SPOOL(0,$P(%ZS,U,1)),%Y,%X,%1,%2,%3 D CLOSE^ZISPL1
+ Q
+ADD(L) S %=%+1,^XMBS(3.519,XS,2,%,0)=L Q
+LIMIT D ADD("*** INCOMPLETE REPORT  -- SPOOL DOCUMENT LINE LIMIT EXCEEDED ***") S $P(^XMB(3.51,%ZDA,0),"^",11)=1
+ Q
+CLVMS ;Close for Cache VMS
+ N $ES,$ET S $ET="D:$EC'[""ENDOF"" ^%ZTER,UNWIND^%ZTER S $EC="""" D SPLEX^%ZIS4,UNWIND^%ZTER"
+ S %ZA=$ZU(68,40,1) ;Work like DSM
+ ;%ZFN Could be set at the top
+ S %ZFN=$S($G(%ZFN)]"":%ZFN,1:$P(%ZS,"^",2)) D SPL3 Q:%ZFN']""  U %ZFN S %ZCR=$C(13),%Y=""
+ S %Z1=+$G(^XTV(8989.3,1,"SPL")),%=0
+ F  R %X#255:5 Q:$ZEOF<0  D  G:%Z1<% SPLEX
+ . I %Z1<% D LIMIT Q
+ . I %X[$C(12) D  Q
+ . . S %Y=$P(%X,$C(12)) D:$L(%Y) ADD(%Y),ADD("|TOP|")
+ . . S %Y=$P(%X,$C(12),2) D:$L(%Y) ADD(%Y)
+ . . Q
+ . D ADD(%X)
+ . Q
+SPLEX C %ZFN:"D" K:%ZFN]"" IO(1,%ZFN) D CLOSE^ZISPL1 K %Y,%X,%1,%ZFN Q
+ ;
+ ;
+HFS G HFS^%ZISF
+REWMT(IO2,IOPAR) ;Rewind Magtape
+ N $ETRAP S $ET="G REWERR^%ZIS4"
+ U IO2 W *5
+ Q 1
+REWSDP(IO2,IOPAR) ;Rewind SDP
+ G REW1
+REWHFS(IO2,IOPAR) ;Rewind Host File.
+REW1 ;ZIS set % to the current $I so need to update % if = IO
+ N NIO,OP,$ETRAP
+ S $ET="G REWERR^%ZIS4"
+ C IO2 ;You do a rewind to read the file.
+ S OP=$S($ZV["VMS":"RV",1:"RS")
+ O IO2:(OP):1 S IO(1,IO2)=""
+ Q 1
+REWERR ;Error encountered
+ S IO("ERROR")=$EC,$ECODE=""
+ Q 0
